<h1>Orders</h1>
<table mat-table [dataSource]="dataSource" matSort matSortActive="timestamp" matSortDirection="desc">
  <tr mat-header-row *matHeaderRowDef="columnsToDisplay" class="first-header-row"></tr>
  <tr mat-header-row *matHeaderRowDef="filterRow" class="second-header-row"></tr>
  <tr mat-row *matRowDef="let row; columns: columnsToDisplay"></tr>

  <ng-container matColumnDef="id-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="timestamp-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 350px"></th>
  </ng-container>

  <ng-container matColumnDef="username-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 350px">
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="usernameFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="sum-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="products-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="actions-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="cancelled-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="id">
    <th mat-header-cell *matHeaderCellDef>ID</th>
    <td mat-cell *matCellDef="let row">{{row.id || '-'}}</td>
  </ng-container>
  <ng-container matColumnDef="timestamp">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Timestamp</th>
    <td mat-cell *matCellDef="let row">{{row.timestamp |date:'yyyy-MM-dd hh:mm:ss'}}</td>
  </ng-container>
  <ng-container matColumnDef="username">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>User</th>
    <td mat-cell *matCellDef="let row">{{row.account.email || '-'}}</td>
  </ng-container>
  <ng-container matColumnDef="sum">
    <th mat-header-cell *matHeaderCellDef>Balance</th>
    <td mat-cell *matCellDef="let row">{{row.sum | currency}}</td>
  </ng-container>
  <ng-container matColumnDef="products">
    <th mat-header-cell *matHeaderCellDef>Products</th>
    <td mat-cell *matCellDef="let row">{{row.entries | concatProducts}}</td>
  </ng-container>
  <ng-container matColumnDef="cancelled">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Cancelled</th>
    <td mat-cell *matCellDef="let row">
      <input type="checkbox" [checked]="row.cancelled"
             [ngClass]="{'is-invalid':row.cancelled,'is-valid':!row.cancelled}" disabled/>
    </td>
  </ng-container>
  <ng-container matColumnDef="actions">
    <th mat-header-cell *matHeaderCellDef>Actions</th>
    <td mat-cell *matCellDef="let row">
      <div class="btn-group btn-group-sm" role="group">
        <a class="btn btn-outline-primary" [routerLink]="['/transactions', row.id]" title="Details">
          <fa-icon [icon]="faInfo" [fixedWidth]="true"></fa-icon>
        </a>
      </div>
    </td>
  </ng-container>

</table>
<mat-paginator [length]="dataSource.totalCount" [pageSize]="dataSource.pageSize"
               [pageSizeOptions]="[5, 10, 20, 50]" showFirstLastButtons></mat-paginator>
